package cn.com.infosec.asn1.crmf;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.x509.GeneralName;

public class SinglePubInfo extends ASN1Encodable {
   private DERInteger pubMethod;
   private GeneralName pubLocation;

   private SinglePubInfo(ASN1Sequence seq) {
      this.pubMethod = DERInteger.getInstance(seq.getObjectAt(0));
      if (seq.size() == 2) {
         this.pubLocation = GeneralName.getInstance(seq.getObjectAt(1));
      }

   }

   public static SinglePubInfo getInstance(Object o) {
      if (o instanceof SinglePubInfo) {
         return (SinglePubInfo)o;
      } else if (o instanceof ASN1Sequence) {
         return new SinglePubInfo((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   public GeneralName getPubLocation() {
      return this.pubLocation;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10001 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var10001.add(this.pubMethod);
      GeneralName var2;
      if ((var2 = this.pubLocation) != null) {
         var1.add(var2);
      }

      return new DERSequence(var1);
   }
}
